<?php
/**
 * STRESS WEB
 * @author S.T.R.E.S.S.
 * @copyright 2008 - 2012 STRESS WEB
 * @version 13
 * @web http://stressweb.ru
 */
if ( !defined("STRESSWEB") )
    die( "Access denied..." );
$_do = ( isset($_REQUEST["do"]) and ($_REQUEST["do"] == "ip" or $_REQUEST['do'] == 'hwid') ) ? "unbind":"request";

if ( $_do == "unbind" ) {
    $hash = ( isset($_REQUEST["hash"]) ) ? urldecode( $_REQUEST["hash"] ):"";
    if ( empty($hash) ) {
        $_do = 'request';
    } else {
        $hash = explode( '|', base64_decode($hash) );
        if ( count($hash) != 6 or md5($hash[0].$hash[1].$hash[2].$hash[3].$hash[4].$l2cfg['salt']) != $hash[5] ) {
            $tpl->SetResult( 'content', "<div class='error'>incorrect hash</div>" );
        } elseif ( time() > $hash[2] + 259200 ) {
            $tpl->SetResult( 'content', "<div class='error'>{$lang["lost_err_2"]}</div>" );
        } elseif ( $hash[3] != $sid ) {
            $tpl->SetResult( 'content', "<div class='error'>incorrect server id</div>" );
        } else {

            $db->ldb( $lid );

            if ( $hash[4] == 'hwid' ) {
                $ldb[$lid]->query( "UPDATE `accounts` SET `hwid`='*' WHERE `login`='".$ldb[$lid]->safe($hash[0])."' AND `l2email`='{$hash[1]}'" );
                if ( $ldb[$lid]->affected() > 0 ) {
                    $tpl->SetResult( 'content', "<div class='noerror'>Ваш аккаунт успешно отвязан</div>" );
                } else {
                    $tpl->SetResult( 'content', "<div class='error'>{$lang["err_db"]}</div>" );
                }
            }
            if ( $hash[4] == 'ip' ) {
                $ldb[$lid]->query( "UPDATE `accounts` SET `allowed_ip`='*' WHERE `login`='".$ldb[$lid]->safe($hash[0])."' AND `l2email`='{$hash[1]}'" );
                if ( $ldb[$lid]->affected() > 0 ) {
                    $tpl->SetResult( 'content', "<div class='noerror'>Ваш IP адрес успешно отвязан</div>" );
                } else {
                    $tpl->SetResult( 'content', "<div class='error'>{$lang["err_db"]}</div>" );
                }
            }
        }
    }
}

if ( $_do == "request" ) {
    $tpl->LoadView( "unbind" );
    if ( count($lsList) > 1 ) {
        $l2servers = "";
        foreach ( $gsList as $key ) {
            $l2servers .= "<option value='{$key}'>{$l2cfg["gs"][$key]["title"]}</option>";
        }
        $tpl->Block( 'servers' );
        $tpl->Set( "servers", $l2servers );
    } else
        $tpl->Block( 'servers', false );

    $tpl->template = '<script type="text/javascript">//<![CDATA[
function reload () {
	var rndval = new Date().getTime(); 
	document.getElementById(\'captcha-repass\').innerHTML = \'<a onclick="reload(); return false;" href="#"><img src="'.HTTP_HOME_URL.'/module/antibot.php?rndval=\' + rndval + \'" border="0"></a>\';
};
//]]></script>'.$tpl->template;
    $tpl->Block( 'captcha' );
    $tpl->Set( "captcha", "<div id=\"captcha-repass\" class='captcha'><a onclick=\"reload(); return false;\" href=\"#\"><img src=\"".HTTP_HOME_URL."/module/antibot.php\" alt=\"code\" border=\"0\" /></a></div>" );
    $tpl->Build( 'content' );

    if ( isset($_POST['unbind']) ) {

        $code_post = strtoupper( $db->safe($_POST["seccode"]) );
        $code_sess = $controller->sess_get( 'seccode' );
        $controller->sess_unset( "seccode" );

        $login = $db->safe( trim($_POST["login"]) );
        $email = $db->safe( $_POST["email"] );
        $type = $db->safe( $_POST['type'] );

        if ( empty($login) or empty($email) or empty($code_post) )
            $tpl->ShowError( $lang["error"], $lang["reg_err_1"] );
        elseif ( !$code_sess or $code_post != $code_sess )
            $tpl->ShowError( $lang["error"], $lang["err_code"] );
        elseif ( !filter_var($email, FILTER_VALIDATE_EMAIL) )
            $tpl->ShowError( $lang["error"], $lang["err_mail"] );
        else {

            $db->ldb( $lid );

            if ( $ldb[$lid]->num_rows($ldb[$lid]->query("SELECT login FROM accounts WHERE login='{$login}' AND l2email='{$email}' LIMIT 1")) == 0 ) {
                $tpl->ShowError( $lang["error"], $lang["lost_err_1"] );
            } else {

                $time = time();
                $hash = urlencode( base64_encode($login.'|'.$email.'|'.$time.'|'.$sid.'|'.$type.'|'.md5($login.$email.$time.$sid.$type.$l2cfg['salt'])) );
                $tpl->LoadView( "email_unbind" );
                if ( $type == 'ip' ) {
                    $tpl->Block( 'ip' );
                    $tpl->Block( 'hwid', false );
                    $tpl->Set( "link", HTTP_HOME_URL."/index.php?f=unbind&do=ip&sid={$sid}&hash={$hash}" );
                } else {
                    $tpl->Block( 'ip', false );
                    $tpl->Block( 'hwid' );
                    $tpl->Set( "link", HTTP_HOME_URL."/index.php?f=unbind&do=hwid&sid={$sid}&hash={$hash}" );
                }
                $tpl->Set( "host", HTTP_HOME_URL );
                $tpl->Set( "login", $login );
                $tpl->Build( "unbind" );
                $mail_message = $tpl->GetResult( "unbind" );

                $mail = new Email( $l2cfg );
                $mail->send( $email, 'Отвязка аккаунта', $mail_message );
                if ( $mail->send_error ) {
                    $tpl->SetResult( 'content', $mail->smtp_msg, true );
                } else {
                    $tpl->SetResult( 'content', "<div class='noerror'>На ваш E-Mail адрес, указанный при регистрации, было отправлено письмо с ссылкой для отвязки аккаунта!</div>", true );
                }
            }
        }
    }
}
?>